var pattern = /(['`"]|&quot;)((\/)(builder|fonts|images|img|jClocksGMT|ml|prt)(\/)(.*?))(\?.*)?(\1)/g;
var hasHtmlPattern = /(['`"]|&quot;)((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(.html)(\?.*)?(\1)/g;
var needHtmlPattern = /(['`"]|&quot;)((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(\?.*)?(\1)/g;
var pathPattern = /^((\/)(builder|fonts|images|img|jClocksGMT|ml|prt)(\/)(.*?))(\?.*)?$/g;
var pathHasHtmlPattern = /^((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(.html)(\?.*)?$/g;
var pathNeedHtmlPattern = /^((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(\?.*)?$/g;
var hasTripleSlasher = /^(file|http|https):(\/{2,3})(.*)$/g;
var SourcePatcher = /** @class */ (function () {
    function SourcePatcher() {
    }
    SourcePatcher.patch = function (source) {
        var res = source.replace(pattern, "$1" + SourcePatcher.baseUri + "$2$8")
            .replace(hasHtmlPattern, "$1" + SourcePatcher.baseUri + "$2$6$7$8")
            .replace(needHtmlPattern, "$1" + SourcePatcher.baseUri + "$2.html$6$7")
            .replace(hasTripleSlasher, "$1//$3");
        return res;
    };
    SourcePatcher.fixPath = function (path) {
        var res = path.replace(pathPattern, SourcePatcher.baseUri + "$&")
            .replace(pathHasHtmlPattern, SourcePatcher.baseUri + "$&")
            .replace(pathNeedHtmlPattern, SourcePatcher.baseUri + "$1.html$5")
            .replace(hasTripleSlasher, "$1//$3");
        return res;
    };
    SourcePatcher.baseUri = "";
    return SourcePatcher;
}());
// const str = `<img src="/ml/9/999_test.jpg">
// var fn = '/ml/9/999_kkkk.jpg';
// <script src="/builder/test.js" style="background-image: url(&quot;/ml/2099/test.jpg&quot;)">
// "/embed/299_17?tx=15"
// "/embed/299_16.html?tx=45"
// "/embed/299_17"
// "/embed/299_16.html"`;
// console.log(SourcePatcher.patch(str));
// console.log(SourcePatcher.fixPath('/embed/123_456.html?tx=45'));
// console.log(SourcePatcher.fixPath('/embed/123_456?tx=45'));
// SourcePatcher.baseUri = '/test/123';
// console.log(SourcePatcher.patch(str));
// console.log(SourcePatcher.fixPath('/embed/123_456.html?tx=45'));
// console.log(SourcePatcher.fixPath('/embed/123_456?tx=45'));
