var OverlayPanel = /** @class */ (function () {
    function OverlayPanel() {
    }
    OverlayPanel.show = function (list) {
        OverlayPanel.visible = (list !== undefined);
        var existing = document.getElementById('overlayWrapper');
        if (OverlayPanel.visible) {
            if (!existing) {
                OverlayPanel.overWrap = document.createElement('div');
                OverlayPanel.overWrap.className = 'overlayWrapper';
                OverlayPanel.overWrap.id = 'overlayWrapper';
                document.body.insertBefore(OverlayPanel.overWrap, document.body.firstChild);
                var details = "";
                for (var d = 0; d < list.length; d++) {
                    if (list[d].v) {
                        details += "<div class=\"row\"><label>" + list[d].n + "</label><span>" + list[d].v + "</span></div>";
                    }
                }
                details += "<div class=\"row\"><label>Local Time</label><span id=\"localtime\">pending</span></div>";
                console.info(details);
                OverlayPanel.overWrap.innerHTML = details;
                setTimeout(OverlayPanel.updateTime, 100); // first update after 1/10 of a second
            }
        }
        else {
            if (existing) {
                existing.remove();
            }
        }
    };
    OverlayPanel.updateTime = function () {
        var t = document.getElementById('localtime');
        if (t) {
            var now = moment();
            var ct = now.format("YYYY-MM-DD hh:mm:ss a");
            if (t.innerText != ct) {
                t.innerText = ct;
            }
            var nextSecond = 1000 - now.milliseconds();
            setTimeout(OverlayPanel.updateTime, nextSecond);
        }
    };
    OverlayPanel.hide = function () {
        OverlayPanel.show(); // call show with no arguments
    };
    return OverlayPanel;
}());
