"use strict";
/// <reference path="../../../Dev/src/jquery.d.ts" />
/// <reference path="../../../Dev/src/interfaces.ts" />
/// <reference path="../../../Dev/src/enums.ts" />
/// <reference path="../../../Dev/src/Utility.ts" />
/// <reference path="../../../Dev/src/logger.ts" />
/// <reference path="../js/main.ts" />
/// <reference path="../js/cordova/2.7.0/cordova.webos.js" />
/// <reference path="../js/cordova-cd/configuration.js" />
/// <reference path="../js/cordova-cd/power.js" />
/// <reference path="../js/cordova-cd/storage.js" />
/// <reference path="../js/webOS/custom.js" />
/// <reference path="../js/webOSjs-0.1.0/webOS.js" />
// declare class Power {
//     getPowerStatus(i, j);
//     enableAllOnTimer(j, k, l);
//     enableAllOffTimer(j, k, l);
//     enableWakeOnLan(j, k, l);
//     addOnTimer(j, k, l);
//     deleteOnTimer(j, k, l);
//     addOffTimer(j, k, l);
//     deleteOffTimer(j, k, l);
//     getOnTimerList(i, j);
//     getOffTimerList(i, j);
//     setDisplayMode(j, k, l);
//     executePowerCommand(j, k, l);
//     setDPMWakeup(j, l, m);
//     getDPMWakeup(i, j);
//     setPMMode(j, k, l);
//     getPMMode(i, j);
//     setPowerOnDelay(j, k, l);
//     getPowerOnDelay(i, j);
//     getOnOffTimeSchedule(i, j);
//     setOnOffTimeSchedule(i, j, k);
//     unsetOnOffTimeSchedule(i, j);
//     static PowerCommand: web_os.PowerCommand | any;
//     static PMMode: any;  // web_os.PMMode;
// }
var _globablPal = null;
function getKorbytPlayerPal() {
    if (!_globablPal) {
        _globablPal = new WebOSPal();
    }
    return _globablPal;
}
var webOsScheduleDays;
(function (webOsScheduleDays) {
    webOsScheduleDays[webOsScheduleDays["mon"] = 1] = "mon";
    webOsScheduleDays[webOsScheduleDays["tue"] = 2] = "tue";
    webOsScheduleDays[webOsScheduleDays["wed"] = 3] = "wed";
    webOsScheduleDays[webOsScheduleDays["thu"] = 4] = "thu";
    webOsScheduleDays[webOsScheduleDays["fri"] = 5] = "fri";
    webOsScheduleDays[webOsScheduleDays["sat"] = 6] = "sat";
    webOsScheduleDays[webOsScheduleDays["sun"] = 0] = "sun";
})(webOsScheduleDays || (webOsScheduleDays = {}));
// const KorbytSettingsFilename: string = 'file://internal/KorbytSettings';
var WebOSPal = /** @class */ (function () {
    function WebOSPal() {
        this.isInitialized = false;
        this.showVisibleLogger = false;
        this.orientation = 0;
        console.debug("Made a Platform-Abstraction-Layer");
    }
    Object.defineProperty(WebOSPal.prototype, "storage", {
        get: function () {
            if (!this._webOsStorage) {
                this._webOsStorage = new Storage();
            }
            return this._webOsStorage;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebOSPal.prototype, "configuration", {
        get: function () {
            if (!this._webOsConfiguration) {
                this._webOsConfiguration = new Configuration();
            }
            return this._webOsConfiguration;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebOSPal.prototype, "power", {
        get: function () {
            if (!this._webOsPower) {
                this._webOsPower = new Power();
            }
            return this._webOsPower;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebOSPal.prototype, "CheckInResults", {
        get: function () {
            try {
                if (!this.__checkInResults) {
                    this.__checkInResults = localStorage.getItem('instructions');
                    if (typeof this.__checkInResults === 'string') {
                        this.__checkInResults = JSON.parse(this.__checkInResults);
                    }
                }
            }
            catch (err) {
                console.error(err);
            }
            return this.__checkInResults;
        },
        set: function (cir) {
            if (cir) {
                this.__checkInResults = cir;
                _klogger.info("localStorage.setItem ---  instructions === " + JSON.stringify(this.__checkInResults));
                localStorage.setItem('instructions', JSON.stringify(this.__checkInResults));
            }
            else {
                localStorage.removeItem('instructions');
                _klogger.warn("CheckInResults === null --- cleared");
            }
        },
        enumerable: true,
        configurable: true
    });
    WebOSPal.prototype.macAddress = function (ni) {
        console.debug('---------- WebOSPal.macAddress()');
        var macAddress = [];
        for (var _interface in ni) {
            var map = [];
            for (var i = 0; i < ni[_interface].length; i++) {
                if (ni[_interface][i].address) {
                    var mac = ni[_interface][i].mac;
                    if (mac && mac !== "" && !map[mac]) {
                        macAddress.push({ 'interface': _interface, 'address': mac });
                        map[mac] = true;
                    }
                }
            }
        }
        return macAddress;
    };
    Object.defineProperty(WebOSPal.prototype, "provisioningToken", {
        get: function () {
            if (!WebOSPal.__provisioningToken) {
                console.debug("---------- WebOSPal.provisioningToken");
                if (this.wiredMac) {
                    WebOSPal.__provisioningToken = Utility.encodeMac(this.wiredMac);
                }
            }
            return WebOSPal.__provisioningToken;
        },
        enumerable: true,
        configurable: true
    });
    WebOSPal.prototype.provisioningDetails = function (callback) {
        console.debug('WebOSPal.provisioningDetails()');
        var self = this;
        return self.checkinGetInfo(function (ci, err) {
            var details = [];
            try {
                var gotMac = false;
                details.push({ n: 'Model', v: ci.model });
                details.push({ n: 'Firmware', v: ci.osVersion });
                details.push({ n: 'Name', v: ci.player_name });
                details.push({ n: 'Software Version', v: ci.version });
                details.push({ n: 'Serial Number', v: ci.serialNumber });
                details.push({ n: 'Caching', v: main.cachingPlayerEnabled.toString() });
                for (var i_1 in ci.networkInterfaces) {
                    var nia = ci.networkInterfaces[i_1];
                    for (var j in nia) {
                        var ni = nia[j];
                        if (ni.address && ni.address != '') {
                            if (ni.mac && ni.mac != '') {
                                details.push({ n: 'MAC Address', v: ni.mac.replace(/:/g, '') });
                            }
                            if (!gotMac) {
                                gotMac = true;
                                details.push({ n: 'IP Address', v: ni.address });
                            }
                        }
                    }
                }
            }
            catch (err) {
                var errMsg = "provisioningDetails() failed: " + JSON.stringify(err);
                console.error(errMsg);
                _klogger.error(errMsg);
            }
            callback(details);
        });
    };
    WebOSPal.prototype.checkProvisioning = function (webService, callback) {
        console.debug("WebOSPal.checkProvisioning(" + webService + ")");
        var self = this;
        $.ajax({
            url: webService + ("/v1/check?pt=" + self.provisioningToken),
            type: "GET",
            dataType: "json",
            success: function (data) {
                // console.info("---------- checkProvisioning: " + JSON.stringify(data));
                if (data.provisioned) {
                    self.provisioning = data;
                    return callback();
                }
                else {
                    return callback();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.error("pal.checkProvisioning() Error - " + thrownError || ajaxOptions);
                _klogger.error(thrownError);
                return callback();
            },
        });
    };
    WebOSPal.prototype.parseSettingsFile = function (settings) {
        // _klogger.debug(`TizenPal.parseSettingsFile(${JSON.stringify(settings)})`);
        try {
            this.wsUrl = settings.wsUrl || '';
            this.wiredMac = (settings.wiredMac || '').toLowerCase();
            this.wirelessMac = (settings.wirelessMac || '').toLowerCase();
            this.player_name = settings.player_name || '';
            this.playerID = settings.playerID || 0;
            this.provisioning = settings.provisioning || { provisioned: false };
            this.serialNumber = settings.serialNumber;
            this.orientation = settings.orientation;
            if (!this.CheckInResults) {
                if (typeof settings.checkInResults === 'string') {
                    settings.checkInResults = JSON.parse(settings.checkInResults);
                }
                if (settings.checkInResults) {
                    this.CheckInResults = settings.checkInResults;
                }
            }
            // ResourceManager.FullDownloadPath = settings.FullDownloadPath;
            // ResourceManager.PlayerSplashFullPath = settings.PlayerSplashFullPat;
        }
        catch (err) {
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.loadSettings = function (callback) {
        console.debug('WebOSPal.loadSettings()');
        try {
            var textData = localStorage.getItem(settingsFileName);
            if (textData) {
                this.savedSettings = textData;
                var loadedSettings = JSON.parse(this.savedSettings);
                this.wsUrl = loadedSettings.wsUrl || '';
                this.wiredMac = (loadedSettings.wiredMac || '').toLowerCase();
                this.wirelessMac = (loadedSettings.wirelessMac || '').toLowerCase();
                this.player_name = loadedSettings.player_name || '';
                this.playerID = loadedSettings.playerID || 0;
                this.provisioning = loadedSettings.provisioning || { provisioned: false };
            }
            return callback(null);
        }
        catch (err) {
            return callback(err.stack || err.message);
        }
    };
    WebOSPal.prototype.saveSettings = function (callback) {
        console.debug('WebOSPal.saveSettings()');
        try {
            var settings = {
                wsUrl: this.wsUrl || '',
                wiredMac: this.wiredMac || '',
                wirelessMac: this.wirelessMac || '',
                player_name: this.player_name || '',
                playerID: this.playerID || 0,
                provisioning: this.provisioning || { provisioned: false, webService: '' },
                serialNumber: this.serialNumber,
                orientation: this.orientation,
                checkInResults: this.CheckInResults,
            };
            var textData = JSON.stringify(settings);
            if (textData === this.savedSettings) {
                return callback(null);
            }
            localStorage.setItem(settingsFileName, textData);
            return callback(null);
        }
        catch (err) {
            _klogger.error(err);
            callback(err.stack || err.message);
        }
    };
    WebOSPal.prototype.checkinCompleted = function (callback) {
        _klogger.debug('WebOSPal.checkinCompleted()');
        var self = this;
        self.checkInData.platform = 'webos';
        // self.checkInData.userAgent = navigator.userAgent;
        self.checkInData.upgradeFilePattern = '^[a-zA-Z0-9-_ .]+[.]ipk';
        self.checkInData.properties = [
            {
                name: "orientation",
                displayName: "Orientation",
                tooltip: "Display orientation",
                type: "dropdown",
                default: this.orientation,
                values: [
                    ["0", "Landscape"],
                    ["90", "Portrait"]
                ]
            }
        ];
        self.checkInData.capabilities = {
            screenShot: true,
            sleepSchedule: false,
            uploadLogs: true,
            remoteUpgrade: true,
            // videoFileExtensions: [".asf", ".wmv", ".divx", ".avi", ".mp4", ".m4v", ".mov", ".3gp", ".3g2", ".mkv", ".ts", ".trp", ".tp", ".mts", ".mpg", ".mpeg", ".dat", ".vob", ".webm"],
            // videoCodecs: ["H.264", "AVC", "MPEG-4", "DivX3.11", "DivX4", "DivX5", "DivX6", "XVID", , "MJpeg", "VC-1", "VP8", "VP9"],
            // audioFileExtensions: [".mp3", ".wav", ".ogg", ".wma"],
            // audioCodecs: ["Vorbis", "Opus", "AAC", "PCM", "MP3", "DTS", "LPCM", "ADPCM", "Dolby Digital", "Dolby Digital Plus", "WMA 9", "WMA", "AMR-NB", "AMR-WB"]
            verbs: [
                "checkin",
                // "clear-cache",
                // "hide-QR",
                // "hotkey",
                // "overlay",
                "playerlog",
                //"remove",
                "rename",
                // "show-QR",
                //"setresolution",
                "screenshot",
                "sleepTimes",
                //"upgrade",
                "urgent",
                "volume"
            ],
            hotkeys: [
                //"ARROWDOWN:Y:Rotate Display 180 degrees",
                //"ARROWLEFT:Y:Rotate Display 270 degrees",
                //"ARROWRIGHT:Y:Rotate Display 90 degrees",
                //"ARROWUP:Y:Rotate Display 0 degrees",
                "C:N:Clear Cache",
                //"D:N:Toggle Debugger",
                "I:N:Toggle Identity",
                //"L:Y:Login",
                //"Q:N:QR code toggle",
                "R:Y:Reboot",
                //"U:N:UI Debugger",
                "X:Y:Player Exit",
            ]
        };
        // this.saveSettings(() => {
        //     console.debug('CHECK-IN DATA:\n' + JSON.stringify(self.checkInData, undefined, 4));
        callback(self.checkInData, null);
        // });
    };
    WebOSPal.prototype.setOrientation = function (orient) {
        var self = this;
        try {
            var mode_1;
            switch (orient) {
                case 90:
                case 270:
                    mode_1 = Signage.OsdPortraitMode.ON;
                    orient = 90;
                    break;
                default:
                    mode_1 = Signage.OsdPortraitMode.OFF;
                    orient = 0;
                    break;
            }
            var opts = { portraitMode: mode_1 };
            var signage = new Signage();
            signage.setPortraitMode(function (cbSuccess) {
                _klogger.info("Portrait Mode set: " + mode_1);
                self.orientation = orient;
            }, function (cbError) {
                _klogger.log("[" + cbError.errorCode + "]: " + cbError.errorText);
            }, opts);
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.setSoundVolume = function (sndLevel) {
        try {
            if (sndLevel < 0)
                sndLevel = 0;
            if (sndLevel > 100)
                sndLevel = 100;
            var sound = new Sound();
            sound.setVolumeLevel(function (cbObject) {
                console.debug("setSoundVolume() success: " + JSON.stringify(cbObject));
            }, function (cbObject) {
                console.error("setSoundVolume() failure: " + JSON.stringify(cbObject));
            }, {
                level: sndLevel,
                volOsdEnabled: true
            });
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.getCpuMemLoads = function (callback) {
        var dskLoad = 0, cpuLoad = 0, memLoad = 0;
        function successCb(cbObject) {
            try {
                memLoad = (cbObject.memory.total > 0) ? (cbObject.memory.used / cbObject.memory.total) * 100 : 0;
                // Get usage information in percentage
                var cpus = cbObject.cpus;
                var cpuTotal = 0;
                var cpuUser = 0;
                for (var i_2 = 0, len = cpus.length; i_2 < len; i_2++) {
                    // console.log("CPU %s:", i);
                    var cpu = cpus[i_2];
                    for (var type in cpu.times)
                        cpuTotal += cpu.times[type];
                    cpuUser += cpu.times.user;
                }
                cpuLoad = (cpuUser / cpuTotal) * 100;
                return callback(cpuLoad, memLoad, dskLoad);
            }
            catch (err) {
                _klogger.error(err);
                return callback(cpuLoad, memLoad, dskLoad);
            }
        }
        function failureCb(cbObject) {
            _klogger.log("getCpuLoad() [" + cbObject.errorCode + "]: " + cbObject.errorText);
            return callback(cpuLoad, memLoad, dskLoad);
        }
        return this.getStorageLoad(function (load) {
            dskLoad = load * 100;
            var deviceInfo = new DeviceInfo();
            return deviceInfo.getSystemUsageInfo(successCb, failureCb, { cpus: true, memory: true });
        });
    };
    WebOSPal.prototype.getStorageLoad = function (callback) {
        try {
            var storage = new Storage();
            storage.getStorageInfo(function (cbObject) {
                if (cbObject.total) {
                    var load = (cbObject.used / cbObject.total) * 100;
                    return callback(load);
                }
                return callback(0);
            }, function (err) {
                _klogger.error("getStorageLoad() Error(" + err.errorCode + "): " + err.errorText);
                return callback(0);
            });
            // return tizen.systeminfo.getPropertyValue("STORAGE", (storage) => {
            //     try {
            //         if (storage && storage.units && storage.units.length > 0) {
            //             var unit = storage.units[0];
            //             return callback((unit.availableCapacity / unit.capacity) * 100);
            //         }
            //     } catch (err) {
            //         _klogger.error(err);
            //     }
            //     return callback(undefined);
            // }, (err) => {
            //     _klogger.error(err);
            //     return callback(undefined);
            // });
        }
        catch (err) {
            _klogger.error(err);
            return callback(0);
        }
    };
    WebOSPal.prototype.checkinSoundVolume = function (callback) {
        var self = this;
        try {
            var sound = new Sound();
            return sound.getSoundStatus(function (cbObject) {
                _klogger.log("cbObject : " + JSON.stringify(cbObject));
                self.checkInData.volume = "" + cbObject.level;
                return self.checkinCompleted(callback);
            }, function (cbObject) {
                _klogger.error(cbObject);
                return self.checkinCompleted(callback);
            });
        }
        catch (err) {
            _klogger.error(err);
            return self.checkinCompleted(callback);
        }
    };
    WebOSPal.prototype.parseLgNetworkIface = function (lgIFace, macAddress, defaultName) {
        // console.debug('WebOSPal.parseLgNetworkIface()');
        var iFace = {};
        if (macAddress && macAddress.length > 0) {
            try {
                iFace.address = lgIFace.ipAddress;
                iFace.netmask = lgIFace.netmask;
                if (lgIFace.ipAddress) {
                    iFace.family = (lgIFace.ipAddress.indexOf('.') > 0) ? 'IPv4' : 'IPv6';
                }
                iFace.mac = macAddress;
                var name_1 = lgIFace.interfaceName || defaultName;
                if (!this.checkInData.networkInterfaces[name_1]) {
                    this.checkInData.networkInterfaces[name_1] = [];
                }
                for (var idx = 0; idx < this.checkInData.networkInterfaces[name_1].length; idx++) {
                    if (this.checkInData.networkInterfaces[name_1][idx].mac == iFace.mac)
                        return;
                }
                this.checkInData.networkInterfaces[name_1].push(iFace);
                this.checkInData.macAddress = this.macAddress(this.checkInData.networkInterfaces);
            }
            catch (err) {
                console.error(err);
                _klogger.error(err);
            }
        }
        return iFace;
    };
    WebOSPal.prototype.checkinGetConnectionInfo = function (callback) {
        _klogger.debug('WebOSPal.checkinGetConnectionInfo()');
        var self = this;
        try {
            // One-time call
            return webOS.service.request("luna://com.webos.service.connectionmanager", {
                method: "getStatus",
                onSuccess: function (inResponse) {
                    try {
                        _klogger.log("luna://com.webos.service.connectionmanager ---- Result: " + JSON.stringify(inResponse, null, 4));
                        _klogger;
                        self.parseLgNetworkIface(inResponse.wired, self.wiredMac, 'eth0');
                        self.parseLgNetworkIface(inResponse.wifi, self.wirelessMac, 'wifi0');
                        self.parseLgNetworkIface(inResponse.wifiDirect, '', 'wifiDirect');
                        self.parseLgNetworkIface(inResponse.wan, '', 'wan');
                    }
                    catch (err) {
                        _klogger.error(err);
                    }
                    return self.checkinSoundVolume(callback);
                },
                onFailure: function (inError) {
                    _klogger.log("Failed to get network state");
                    _klogger.log("[" + inError.errorCode + "]: " + inError.errorText);
                    // To-Do something
                    return self.checkinSoundVolume(callback);
                }
            });
        }
        catch (err) {
            _klogger.error(err);
            return self.checkinSoundVolume(callback);
        }
    };
    // checkinGetMacAddressInfo(callback: (ci?: iCheckin, err?: string) => void) {
    //     if (this.wiredMac) {
    //         return this.checkinGetConnectionInfo(callback);
    //     }
    //     const that = this;
    //     function successCallback(data) {
    //         try {
    //             that.wiredMac = data.wiredInfo.macAddress;
    //             that.wirelessMac = data.wifiInfo.macAddress;
    //         } catch (err) {
    //             _klogger.error(err.stack || err.message);
    //         }
    //         return that.checkinGetConnectionInfo(callback);
    //     }
    //     function errorCallback(err) {
    //         _klogger.error(`checkinGetMacAddressInfo() Error Code [${err.errorCode}]: ${err.errorText}`);
    //         return that.checkinGetConnectionInfo(callback);
    //     }
    //     return DeviceInfo.getNetworkMacInfo(successCallback, errorCallback);
    // }
    WebOSPal.prototype.checkinGetMacInfo = function (callback) {
        var self = this;
        if (self.wiredMac) {
            return self.checkinGetConnectionInfo(callback);
        }
        try {
            _klogger.debug('WebOSPal.checkinGetMacInfo()');
            var deviceInfo = new DeviceInfo();
            return deviceInfo.getNetworkMacInfo(function (macInfo) {
                if (macInfo) {
                    if (macInfo.wiredInfo) {
                        self.wiredMac = macInfo.wiredInfo.macAddress;
                    }
                    if (macInfo.wifiInfo) {
                        self.wirelessMac = macInfo.wifiInfo.macAddress;
                    }
                }
                return self.checkinGetConnectionInfo(callback);
            }, function (failure) {
                _klogger.error("getNetworkMacInfo: " + failure);
                return self.checkinGetConnectionInfo(callback);
            });
        }
        catch (err) {
            return self.checkinGetConnectionInfo(callback);
        }
    };
    WebOSPal.prototype.checkinGetPlatformInfo = function (callback) {
        console.debug('WebOSPal.checkinGetPlatformInfo()');
        var self = this;
        try {
            // One-time call
            return webOS.service.request("luna://com.webos.service.tv.systemproperty", {
                method: "getSystemInfo",
                parameters: {
                    "keys": ["modelName", "firmwareVersion", "UHD", "serialNumber"]
                },
                onComplete: function (inResponse) {
                    try {
                        var isSucceeded = inResponse.returnValue;
                        if (isSucceeded) {
                            _klogger.debug("luna://com.webos.service.tv.systemproperty ---- Result: " + JSON.stringify(inResponse));
                            // To-Do something
                            self.checkInData.model = inResponse.modelName;
                            self.checkInData.osVersion = inResponse.firmwareVersion;
                            self.checkInData.serialNumber = inResponse.serialNumber;
                            self.serialNumber = inResponse.serialNumber;
                            if (!self.player_name) {
                                // only set the player name if it is blank.
                                self.player_name = "webOS-" + inResponse.serialNumber;
                            }
                            self.checkInData.player_name = self.player_name;
                            // console.log("Result: " + JSON.stringify(self.checkInData, null, 4));
                        }
                        else {
                            _klogger.error("Failed to get the signage device information:" + JSON.stringify(inResponse));
                            // To-Do something
                            return;
                        }
                    }
                    catch (err) {
                        console.error(err);
                        _klogger.error(err);
                    }
                    return self.checkinGetMacInfo(callback);
                }
            });
        }
        catch (err) {
            console.error("checkinGetPlatformInfo():\n" + err.stack);
            _klogger.error(err);
            return self.checkinGetMacInfo(callback);
        }
    };
    WebOSPal.prototype.checkinGetAppInfo = function (callback) {
        console.debug('WebOSPal.checkinGetAppInfo()');
        var self = this;
        try {
            if (WebOSPal.applicationVersion) {
                self.checkInData.version = WebOSPal.applicationVersion;
            }
            else {
                // Get IPK type app information from appinfo.json.
                var custom = new Custom();
                return custom.Signage.getApplicationInfo(function successCallback(successObject) {
                    console.log('Data from appinfo.json : ' + JSON.stringify(successObject, null, 4));
                    WebOSPal.applicationVersion = successObject.version;
                    self.checkInData.version = successObject.version;
                    return self.checkinGetPlatformInfo(callback);
                }, function failureCallback(failureObject) {
                    console.error(failureObject);
                    _klogger.error('[' + failureObject.errorCode + '] ' + failureObject.errorText);
                    self.checkInData.version = '--.--.--';
                    return self.checkinGetPlatformInfo(callback);
                });
            }
        }
        catch (err) {
            self.checkInData.version = '--.--.--';
            console.error('checkinGetAppInfo() failed:', err);
            _klogger.error(err);
        }
        return self.checkinGetPlatformInfo(callback);
    };
    WebOSPal.prototype.checkinGetInfo = function (callback) {
        console.debug('WebOSPal.checkinGetInfo()');
        try {
            this.checkInData = {};
            if (!this.checkInData.networkInterfaces) {
                this.checkInData.networkInterfaces = {};
            }
            this.checkInData.player_name = this.player_name;
            this.checkInData.model = 'webOS';
            if (this.provisioning && this.provisioning.tenant_token) {
                this.checkInData.tenant_token = this.provisioning.tenant_token;
            }
            this.checkInData.playerID = this.playerID;
            this.checkInData.token = this.provisioningToken;
            this.checkInData.displayInfos = [];
            var displayMode = window.outerWidth + "x" + window.outerHeight;
            var displayOrient = '0 degrees';
            this.checkInData.displayInfos.push({
                port: 'display',
                model_name: this.model,
                active: displayMode,
                preferred: displayMode,
                orientation: displayOrient,
                resolutions: [displayMode]
            });
            this.checkInData.displays = [];
            this.checkInData.displays.push({ port: 'display', resolution: displayMode, screenOrientation: displayOrient });
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
        }
        return this.checkinGetAppInfo(callback);
    };
    WebOSPal.prototype.initializePlatform = function () {
        var self = this;
        return self.power.getPMMode(function (cbObject) {
            console.debug("power.getPMMode(" + JSON.stringify(cbObject) + ")");
            if (cbObject.mode !== "powerOff" /*self.power.PMMode.PowerOff*/) {
                var powerModeOptions = { mode: "powerOff" /*self.power.PMMode.PowerOff*/ };
                return self.power.setPMMode(function (cbObject) {
                    console.debug("power.setPMMode(" + JSON.stringify(cbObject) + ")");
                }, function (cbObject) {
                    console.error("power.setPMMode(" + JSON.stringify(cbObject) + ") FAILED");
                }, powerModeOptions);
            }
        }, function (cbObject) {
            console.error("power.getPMMode(" + JSON.stringify(cbObject) + ") FAILED");
        });
    };
    WebOSPal.prototype.initialize = function (callback) {
        if (!this.isInitialized) {
            console.debug('WebOSPal.initialize()');
            var self_1 = this;
            self_1.isInitialized = true;
            self_1.provisioning = {
                provisioned: false,
                cms: '',
                webService: '',
                tenant_token: ''
            };
            self_1.initializePlatform();
            return self_1.loadSettings(function (err) {
                try {
                    if (err) {
                        _klogger.error(err);
                    }
                    return self_1.checkinGetInfo(function (ci, err) {
                        if (err) {
                            console.error(err);
                            _klogger.error(err);
                        }
                        return callback();
                    });
                }
                catch (err) {
                    console.error(err);
                    return callback();
                }
            });
        }
    };
    WebOSPal.prototype.enableDebugging = function () {
        console.debug('WebOSPal.enableDebugging()');
        var options = { enabled: true };
        this.configuration.debug(function successCb() {
            console.log("Succeeded to enable the debug mode");
        }, function failureCb() {
        }, options);
    };
    WebOSPal.prototype.systemEventHandler = function (event) {
        if (event.temperature && event.temperature > 50) {
            _klogger.info({ systemEventMoniter: event });
            console.debug("System Event [" + event.type + "] from " + event.source + ": " + JSON.stringify(event.data));
        }
    };
    ;
    WebOSPal.prototype.enableSystemEvents = function () {
        var self = this;
        try {
            var signage = new Signage();
            signage.registerSystemMonitor(function () {
                console.debug('enableSystemEvents()->registerSystemMonitor() success');
            }, function (cbObject) {
                _klogger.error("enableSystemEvents()->registerSystemMonitor() Error Code [" + cbObject.errorCode + "]:  " + cbObject.errorText);
            }, {
                monitorConfiguration: {
                    fan: true,
                    lamp: true,
                    screen: true,
                    signal: true,
                    temperature: true
                },
                eventHandler: function (eventData) {
                    self.systemEventHandler(eventData);
                }
            });
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.captureScreenShot = function (callbackPusher) {
        var self = this;
        try {
            var signage = new Signage();
            signage.captureScreen(function (cbObject) {
                try {
                    console.debug("Screenshot capture success: " + cbObject.encoding + ", " + cbObject.size + " bytes");
                    callbackPusher(Utility.b64toBlob(cbObject.data, 'image/jpeg'));
                }
                catch (err) {
                    console.error(err);
                    _klogger.error(err);
                }
            }, function (cbObject) {
                console.error("Screenshot capture failed: " + JSON.stringify(cbObject));
                _klogger.error("Screenshot capture failed: " + JSON.stringify(cbObject));
            }, {
                save: false,
                thumbnail: false,
                imgResolution: Signage.ImgResolution.HD
            });
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.sendMessage = function (msgText, callback) {
        try {
            if (parent) {
                var msg = { to: 'host', message: msgText };
                parent.postMessage(JSON.stringify(msg), parent.location.toString());
            }
            else {
                _klogger.warn("no parent window found - failed postMessage: " + msgText);
            }
        }
        catch (err) {
            _klogger.error(err);
        }
    };
    WebOSPal.prototype.addSleepSchedule = function (callback, schedule) {
        console.debug("Setting sleep schedule: " + JSON.stringify(schedule));
        return this.power.setOnOffTimeSchedule(function (cbObject) {
            console.debug("Sleep schedule set: " + JSON.stringify(cbObject));
            _klogger.info("Sleep schedule set: " + JSON.stringify(cbObject));
            return callback();
        }, function (cbObject) {
            console.error("Sleep schedule failed: " + JSON.stringify(cbObject));
            _klogger.error("Sleep schedule failed: " + JSON.stringify(cbObject));
            return callback();
        }, schedule);
    };
    WebOSPal.prototype.setSleepSchedule = function (callback, schedule) {
        var self = this;
        try {
            // main.notSupported('Sleep schedule is not supported.', callback);
            // SAMPLE:  { sleepTime: "22:01", wakeTime: "07:00", sleepDays: ["0", "1", "2", "3", "4", "5", "6"] }
            //          { sleepTime: "00:00", wakeTime:"00:00", sleepDays:[] } "
            var schd = JSON.parse(schedule);
            var options_1;
            if (schd.sleepDays && schd.sleepDays.length > 0) {
                options_1 = {
                    "onOffTimeSchedule": []
                };
                var onHour = 0;
                var onMinute = 0;
                var parts = schd.wakeTime.split(':');
                if (parts && parts.length === 2) {
                    onHour = parseInt(parts[0]);
                    onMinute = parseInt(parts[1]);
                }
                var offHour = 0;
                var offMinute = 0;
                parts = schd.sleepTime.split(':');
                if (parts && parts.length === 2) {
                    offHour = parseInt(parts[0]);
                    offMinute = parseInt(parts[1]);
                }
                for (var ndx = 0; ndx < schd.sleepDays.length; ndx++) {
                    var dow = parseInt(schd.sleepDays);
                    options_1.onOffTimeSchedule.push({
                        day: webOsScheduleDays[dow],
                        onTime: { hour: onHour, minute: onMinute },
                        offTime: { hour: offHour, minute: offMinute }
                    });
                }
            }
            self.power.unsetOnOffTimeSchedule(function (cbObject) {
                if (options_1) {
                    self.addSleepSchedule(callback, options_1);
                }
                else {
                    return callback();
                }
            }, function (cbObject) {
                _klogger.error(cbObject);
                if (options_1) {
                    self.addSleepSchedule(callback, options_1);
                }
                else {
                    return callback();
                }
            });
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
            return callback();
        }
    };
    WebOSPal.prototype.upgradePlayer_upgradeApplication = function (callback) {
        var self = this;
        try {
            var upgradeOptions = {
                to: self.storage.AppMode.REMOTE,
                recovery: false
            };
            console.debug("storage.upgradeApplication(" + JSON.stringify(upgradeOptions) + ")");
            self.storage.upgradeApplication(function (cbObject) {
                console.debug("upgradeApplication: " + JSON.stringify(cbObject));
                _klogger.info("upgradeApplication: " + JSON.stringify(cbObject));
                main.uploadPlayerLog(function () {
                    callback();
                    self.reboot('Player upgrade');
                });
            }, function (cbObject) {
                console.error("upgradeApplication() FAILED: " + JSON.stringify(cbObject));
                _klogger.error("upgradeApplication() FAILED: " + JSON.stringify(cbObject));
                main.uploadPlayerLog(function () {
                    callback();
                });
            }, upgradeOptions);
        }
        catch (err) {
            console.error("upgradeApplication() FAILED: " + JSON.stringify(err));
            _klogger.error("upgradeApplication() FAILED: " + JSON.stringify(err));
            main.uploadPlayerLog(function () {
                callback();
            });
        }
    };
    WebOSPal.prototype.upgradePlayer = function (callback, packageName) {
        var self = this;
        // _klogger.warn('player upgrade is not supported');
        console.debug("upgradePlayer() started");
        self.configuration.getServerProperty(function (cbObject) {
            console.debug("configuration.getServerProperty(" + JSON.stringify(cbObject) + ")");
            cbObject.appLaunchMode = self.configuration.AppMode.LOCAL;
            cbObject.appType = self.configuration.AppType.IPK;
            cbObject.fqdnAddr = self.provisioning.webService + "/v1/upgradePlayer/" + packageName;
            // cbObject.fqdnAddr = `http://dev-smarttv.rmg.local/webos/korbytplayer.ipk`;
            cbObject.fqdnMode = true;
            self.configuration.setServerProperty(function (cbObject) {
                console.debug("configuration.setServerProperty(" + JSON.stringify(cbObject) + ")");
                self.upgradePlayer_upgradeApplication(callback);
            }, function (cbObject) {
                console.error("configuration.setServerProperty failed: " + JSON.stringify(cbObject));
                _klogger.error("configuration.setServerProperty failed: " + JSON.stringify(cbObject));
                main.uploadPlayerLog(function () {
                    callback();
                });
            }, cbObject);
        }, function (cbObject) {
            console.error("configuration.getServerProperty: " + JSON.stringify(cbObject));
            _klogger.error("configuration.getServerProperty: " + JSON.stringify(cbObject));
            main.uploadPlayerLog(function () {
                callback();
            });
        });
    };
    WebOSPal.prototype.restart = function (reason) {
        _klogger.warn("========== APPLICATION.restart(" + reason + ")");
        if (reason) {
            main.LastRestartReason = reason;
        }
        // location.reload(true);
        this.configuration.restartApplication(function (cbObject) { _klogger.info("configuration.restartApplication(): " + JSON.stringify(cbObject)); }, function (cbObject) { _klogger.error("configuration.restartApplication() FAILED: " + JSON.stringify(cbObject)); });
    };
    WebOSPal.prototype.reboot = function (reason) {
        try {
            _klogger.warn("========== APPLICATION.reboot()");
            // location.reload(true);
            var options = {
                powerCommand: Power.PowerCommand.REBOOT
            };
            if (reason) {
                main.LastRestartReason = reason;
            }
            var power = new Power();
            power.executePowerCommand(function (cbObject) { _klogger.info("power.executePowerCommand(): " + JSON.stringify(cbObject)); }, function (cbObject) { _klogger.error("power.executePowerCommand() FAILED: " + JSON.stringify(cbObject)); }, options);
        }
        catch (err) {
            console.error(err);
            _klogger.error(err);
            main.uploadPlayerLog(function () { });
        }
    };
    WebOSPal.prototype.playerLoadingUrl = function (params, cachingEnabled) {
        if (cachingEnabled) {
            return "./content/weboscached.html?p=" + params;
        }
        else {
            return this.provisioning.cms + "/prt/v17/webosplayer.html?p=" + params;
        }
    };
    WebOSPal.prototype.IsNetworkAvailable = function (callback) {
        // Subscription
        if (!WebOSPal.__connectionManagerSubscriptionHandle) {
            return WebOSPal.__connectionManagerSubscriptionHandle = webOS.service.request("luna://com.webos.service.connectionmanager", {
                method: "getStatus",
                parameters: { "subscribe": true },
                onSuccess: function (inResponse) {
                    if (typeof (inResponse.subscribed) != 'undefined') {
                        if (!inResponse.subscribed) {
                            _klogger.log("Failed to subscribe network state");
                            return callback(true);
                        }
                    }
                    WebOSPal.__isInternetConnectionAvailable = inResponse.isInternetConnectionAvailable;
                    return callback(WebOSPal.__isInternetConnectionAvailable);
                },
                onFailure: function (inError) {
                    _klogger.log("Failed to get network state");
                    _klogger.log("[" + inError.errorCode + "]: " + inError.errorText);
                    // To-Do something
                    return callback(true);
                }
            });
        }
        return callback(WebOSPal.__isInternetConnectionAvailable);
    };
    WebOSPal.__provisioningToken = null;
    WebOSPal.applicationVersion = null;
    return WebOSPal;
}());
