if (dlResource.serverPath.startsWith('/embed/') || dlResource.serverPath.startsWith('/message/') || dlResource.serverPath.startsWith('/urgent/')) {
    dlResource.serverPath = dlResource.serverPath + '.html';
    dlResource.fileName = dlResource.fileName + '.html';
    console.log(`***** THIS FILE STARTS WITH /EMBED: ${dlResource.serverPath} *****`);
    $.ajax({
        type: 'GET',
        url: dlResource.serverUrl,
        dataType: 'HTML',
        headers: {
            Cookie: `tx=${main.pal.provisioning.tenant_number}`,
            Authorization: `Bearer ${main.pal.CheckInResults.bearer}`,
        },
        success: function(res){
            console.log("INSIDE THE AJAX REQUEST");
            // console.log(res); 
            let options = {
                data: res,
                path: `${ResourceManager.cacheRoot}${dlResource.serverPath}`,
                position: 0,
                mode: 'truncate',
                offset: 0,
                length: res.length,
                encoding: 'utf8'
            }                       
            ResourceManager.storage.writeFile(function(data){
                console.log("%%%%% SUCCESS DATA WRITTEN TO FILE %%%%%");
                // console.log(data);
                SourcePatcher.baseUri = ResourceManager.cacheRoot;
                ResourceManager.downloadNext();
                // return ResourceManager.postFileWork(`${ResourceManager.cacheRoot}${dlResource.serverPath}`);

            }, function(error){
                console.log(`ERROR ${JSON.stringify(error)}`);
            }, options);
        }
    })
}
else{
    let options = {
        source: dlResource.serverUrl,
        destination: `${ResourceManager.cacheRoot}${dlResource.serverPath}`,
        httpOptions: {
            headers: {
                Cookie: `tx=${main.pal.provisioning.tenant_number}`,
                Authorization: `Bearer ${main.pal.CheckInResults.bearer}`,
            }
        }
    }
    console.log(`Download Options: ${JSON.stringify(options)}`);

    let successCb = function () {
        _klogger.debug('***** Copy File Success *****');
        console.log('***** Copy File Success *****');
        // return ResourceManager.downloadNext();
        // let options = {path: `file://internal/axyz/prt/v11/manifest.json`};
        // ResourceManager.storage.exists(function (data) {
        //     console.log(`File exists at ${options.path} ? ${JSON.stringify(data.exists)}`);
        //     // console.log(ResourceManager.dlPending);
        //     ResourceManager.downloadNext();
        // }, function (error) {
        //     console.log(`ERROR ${JSON.stringify(error)}`);
        // }, options);
        SourcePatcher.baseUri = ResourceManager.cacheRoot;
        ResourceManager.downloadNext();
        // return ResourceManager.postFileWork(`${ResourceManager.cacheRoot}${dlResource.serverPath}`);
    }
    let failureCb = function (errors) {
        localStorage.removeItem(dlResource.serverPath);
        let errorCode = errors.errorCode;
        let errorMessage = errors.errorMessage;
        _klogger.error(`Errror Code: ${errorCode}; with message: ${errorMessage}`);
        console.log(`Errror Code: ${errorCode}; with message: ${errorMessage}`);
        console.log(JSON.stringify(errors));
        console.log(`DL Pending: ${ResourceManager.dlPending}`);
        return errors;
    }
    try{
        ResourceManager.storage.copyFile(successCb, failureCb, options);
    } catch (err) {
        _klogger.error(err)
    }
}


        //     dlResource.tizenRequest = new tizen.DownloadRequest(url, dlResource.localFullDirectory, dlResource.fileName, 'ALL', headers);

        //     dlResource.downloadId = tizen.download.start(dlResource.tizenRequest, {
        //         onprogress: (id, receivedSize, totalSize) => {
        //             _klogger.debug(`##### ResourceManager.onProgress - ${id}: ${receivedSize} of ${totalSize}`);
        //             clearTimeout(dlResource.dlTimeout);
        //             dlResource.dlTimeout = setTimeout(ResourceManager.downloadOnTimeout, 60 * 1000);
        //         },
        //         onpaused: (id) => {
        //             _klogger.info(`##### ResourceManager.onPaused - download paused: ${id}`);
        //             clearTimeout(dlResource.dlTimeout);
        //             dlResource.dlTimeout = setTimeout(ResourceManager.downloadOnTimeout, 60 * 1000);
        //         },
        //         oncanceled: (id) => {
        //             _klogger.warn(`##### ResourceManager.onCanceled - download canceled: ${id}`);
        //             dlResource.tizenRequest = null;
        //             clearTimeout(dlResource.dlTimeout);

        //             return ResourceManager.downloadNext();
        //         },
        //         oncompleted: (id, fullPath) => {
        //             try {
        //                 _klogger.info(`##### ResourceManager.onCompleted - download completed: ${id} ${fullPath}`);
        //                 if (dlResource) {
        //                     clearTimeout(dlResource.dlTimeout);

        //                     if (!ResourceManager.FullDownloadPath) {
        //                         ResourceManager.FullDownloadPath = fullPath.substr(0, fullPath.length - dlResource.serverPath.length);
        //                         SourcePatcher.baseUri = ResourceManager.FullDownloadPath;
        //                         _klogger.info(`~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FullDownloadPath === ${ResourceManager.FullDownloadPath}`);
        //                     }

        //                     if (dlResource.serverPath.startsWith('/embed/') || dlResource.serverPath.startsWith('/message/') || dlResource.serverPath.startsWith('/urgent/')) {
        //                         dlResource.fileName = dlResource.fileName + '.html';
        //                     }
        //                     let orgName = ResourceManager.getFilename(dlResource.fileName);
        //                     let newName = ResourceManager.getFilename(fullPath);

        //                     if (ResourceManager.isStaticContent(dlResource.serverPath)) {
        //                         ResourceManager.staticCache[dlResource.serverPath] = true;
        //                     }

        //                     if (orgName !== newName) {
        //                         _klogger.debug(`~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ RENAME FILE ${fullPath} ===> ${newName} ===> ${orgName}`)
        //                         return ResourceManager.renameFile(fullPath, orgName, (fileName: string) => {
        //                             return ResourceManager.postFileWork(fileName);
        //                         });
        //                     } else {
        //                         return ResourceManager.postFileWork(fullPath);
        //                     }
        //                 }
        //             } catch (err) {
        //                 _klogger.error(err);
        //             }
        //         },
        //         onfailed: (id, error) => {
        //             dlResource.tizenRequest = null;
        //             clearTimeout(dlResource.dlTimeout);

        //             if (error.code !== -1) {
        //                 _klogger.error(`##### ResourceManager - download failed: ${id} => ${error}`);
        //             } else {
        //                 if (error.message && error.message.indexOf('HTTP status: 304') < 0) {
        //                     _klogger.debug(`##### ResourceManager - download failed: ${id} => ${error}`);
        //                 } else {
        //                     if (ResourceManager.isStaticContent(dlResource.serverPath)) {
        //                         ResourceManager.staticCache[dlResource.serverPath] = true;
        //                     }
        //                 }
        //             }

        //             return ResourceManager.downloadNext();
        //         }
        //     });

        //     dlResource.dlTimeout = setTimeout(() => {
        //         return ResourceManager.downloadOnTimeout(dlResource);
        //     }, 60 * 1000);

        //     _klogger.debug(`##### ResourceManager - started download #${dlResource.downloadId} of '${url}', remaining files ${ResourceManager.dlPending.length}`);



        static do_downloadFile(data: any) {
            console.log("START OF DO_DOWNLOADFILE");
                
            // Download data using AJAX
            var xhr = new XMLHttpRequest();
            xhr.open("GET", data.dlResource.serverUrl, true);
            xhr.setRequestHeader("Content-Type", "application/octet-stream");
            xhr.responseType = "arraybuffer";
        
            // Set the download range for file
            if (data.isGetFileSize) {
                xhr.setRequestHeader("Range", "bytes=" + data.startRange + "-" + data.endRange);
            }
        
            xhr.onerror = function (e) {
                console.error("[ERROR]" + e);
            }
        
            xhr.onreadystatechange = function () {
        
                // First connection
                if (xhr.readyState == 4 && xhr.status == 200) {
                    console.log("Starting to download......");
                }            
                // Initialize case. Get File Size.
                else if (!data.isGetFileSize) {
                    data.isGetFileSize = true;
                    data.totalFileSize = Number(xhr.getResponseHeader("Content-Length"));
                    console.log("File size: " + data.totalFileSize);
                    console.log("Download: " + data.downloadedFileSize)
                    xhr.abort();
                    if (data.downloadedFileSize < data.totalFileSize)
                        ResourceManager.do_downloadFile(data);
                    else if (data.downloadedFileSize == data.totalFileSize)
                        console.log("The file is downloaded completely already.");
                    else
                        console.error("Invalid download");
                }
                // Download data chunk
                else if (xhr.readyState == 4 && xhr.status == 206) {
                    if (data.downloadedFileSize + data.CHUNK_LENGTH > data.totalFileSize)
                        data.downloadedFileSize += data.totalFileSize - data.downloadedFileSize;
                    else data.downloadedFileSize += data.CHUNK_LENGTH;
                    var buf = xhr.response;
                    if (buf) {
                        data.responseBuffer = new Int8Array(buf);
                        data.startRange = data.endRange + 1;
                        data.endRange += data.CHUNK_LENGTH;
                        ResourceManager.appendFile(data);
                    }
                }
            }
        
            xhr.send();
        }
        static appendFile(data: any) {
            console.log("START OF APPENDFILE");
            var successCb = function (cbObject) {
                // Calculate download progress
                var percentage = parseInt((data.downloadedFileSize / data.totalFileSize) * 100);
                console.log("[" + percentage + "%] Downloading : " + data.downloadedFileSize +
                    "/" + data.totalFileSize + " Bytes");
                // Download next data
                if (data.downloadedFileSize < data.totalFileSize) {
                    ResourceManager.do_downloadFile(data);
                }
                // Download completed
                else if (data.downloadedFileSize === data.totalFileSize) {
                    console.log("[" + percentage + "%] Downloading : " +
                    data.downloadedFileSize + "/" +
                    data.totalFileSize + " Bytes");
                    console.log(JSON.stringify(cbObject)); // Print binary array
                    ResourceManager.downloadNext();
                }
                // Error case. Downloaded data size > Original data size
                else {
                    console.error("Invalid write");
                    ResourceManager.do_downloadFile(data);
                }
            };
    
            var failureCb = function (cbObject) {
                var errorCode = cbObject.errorCode;
                var errorText = cbObject.errorText;
                console.log(" Error Code [" + errorCode + "]: " + errorText);
            };
    
            var options = {
                data: data.responseBuffer,
                path: `${ResourceManager.cacheRoot}${data.dlResource.serverPath}`,
                position: 0,
                mode: "append",
                offset: 0,
                length: data.CHUNK_LENGTH,
                encoding: "binary"
            };
    
            // var storage = new Storage();
            ResourceManager.storage.writeFile(successCb, failureCb, options);
        }